diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/block-ack-manager.h ns-3.35/src/wifi/model/block-ack-manager.h
--- ns-3.34/src/wifi/model/block-ack-manager.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/block-ack-manager.h	2021-10-01 13:26:48.000000000 -0700
@@ -32,7 +32,6 @@
 
 namespace ns3 {
 
-class WifiRemoteStationManager;
 class MgtAddBaResponseHeader;
 class MgtAddBaRequestHeader;
 class CtrlBAckResponseHeader;
@@ -79,6 +78,15 @@
    */
   BlockAckManager& operator= (const BlockAckManager& block);
 
+  /**
+   * Enumeration for the statuses of a buffered MPDU
+   */
+  enum MpduStatus : uint8_t
+  {
+    STAY_INFLIGHT = 0,
+    TO_RETRANSMIT,
+    ACKNOWLEDGED
+  };
 
 public:
   /**
@@ -91,12 +99,6 @@
   ~BlockAckManager ();
 
   /**
-   * Set up WifiRemoteStationManager associated with this BlockAckManager.
-   *
-   * \param manager WifiRemoteStationManager associated with this BlockAckManager
-   */
-  void SetWifiRemoteStationManager (const Ptr<WifiRemoteStationManager> manager);
-  /**
    * \param recipient Address of peer station involved in block ack mechanism.
    * \param tid Traffic ID.
    *
@@ -121,11 +123,12 @@
   /**
    * \param reqHdr Relative Add block ack request (action frame).
    * \param recipient Address of peer station involved in block ack mechanism.
+   * \param htSupported Whether both originator and recipient support HT
    *
    * Creates a new block ack agreement in pending state. When a ADDBA response
    * with a successful status code is received, the relative agreement becomes established.
    */
-  void CreateAgreement (const MgtAddBaRequestHeader *reqHdr, Mac48Address recipient);
+  void CreateAgreement (const MgtAddBaRequestHeader *reqHdr, Mac48Address recipient, bool htSupported = true);
   /**
    * \param recipient Address of peer station involved in block ack mechanism.
    * \param tid traffic ID of transmitted packet.
@@ -165,14 +168,6 @@
   Ptr<const WifiMacQueueItem> GetBar (bool remove = true, uint8_t tid = 8,
                                       Mac48Address recipient = Mac48Address::GetBroadcast ());
   /**
-   * Returns true if there are packets that need of retransmission or at least a
-   * BAR is scheduled. Returns false otherwise.
-   *
-   * \return true if there are packets that need of retransmission or at least a BAR is scheduled,
-   *         false otherwise
-   */
-  bool HasPackets (void);
-  /**
    * Invoked upon receipt of an Ack frame after the transmission of a QoS data frame
    * sent under an established block ack agreement. Remove the acknowledged frame
    * from the outstanding packets and update the starting sequence number of the
@@ -194,11 +189,10 @@
    * \param blockAck The received BlockAck frame.
    * \param recipient Sender of BlockAck frame.
    * \param tids the set of TIDs the acknowledged MPDUs belong to
-   * \param rxSnr received SNR of the BlockAck frame itself
-   * \param dataSnr data SNR reported by remote station
-   * \param dataTxVector the TXVECTOR used to send the Data
    * \param index the index of the Per AID TID Info subfield, in case of Multi-STA
    *              Block Ack, or 0, otherwise
+   * \return a pair of values indicating the number of successfully received MPDUs
+   *         and the number of failed MPDUs
    *
    * Invoked upon receipt of a BlockAck frame. Typically, this function, is called
    * by ns3::QosTxop object. Performs a check on which MPDUs, previously sent
@@ -207,9 +201,9 @@
    * Note that <i>tids</i> is only used if <i>blockAck</i> is a Multi-STA Block Ack
    * using All-ack context.
    */
-  void NotifyGotBlockAck (const CtrlBAckResponseHeader& blockAck, Mac48Address recipient,
-                          const std::set<uint8_t>& tids, double rxSnr, double dataSnr,
-                          const WifiTxVector& dataTxVector, size_t index = 0);
+  std::pair<uint16_t,uint16_t> NotifyGotBlockAck (const CtrlBAckResponseHeader& blockAck,
+                                                  Mac48Address recipient, const std::set<uint8_t>& tids,
+                                                  size_t index = 0);
   /**
    * \param recipient Sender of the expected BlockAck frame.
    * \param tid Traffic ID.
@@ -220,15 +214,6 @@
    */
   void NotifyMissedBlockAck (Mac48Address recipient, uint8_t tid);
   /**
-   * \param recipient outstanding frames' receiver.
-   * \param tid Traffic ID.
-   *
-   * Discard all the outstanding MPDUs destined to the given receiver and belonging
-   * to the given TID. Typically, this function is called by ns3::QosTxop object
-   * when it gives up retransmitting either a BlockAckRequest or the Data frames.
-   */
-  void DiscardOutstandingMpdus (Mac48Address recipient, uint8_t tid);
-  /**
    * \param recipient Address of peer station involved in block ack mechanism.
    * \param tid Traffic ID.
    *
@@ -279,12 +264,6 @@
    * and buffered packets) is greater of <i>nPackets</i>, they are transmitted using block ack mechanism.
    */
   void SetBlockAckThreshold (uint8_t nPackets);
-  /**
-   * \return the retransmit queue.
-   *
-   * Return the retransmit queue.
-   */
-  Ptr<WifiMacQueue> GetRetransmitQueue (void);
 
   /**
    * \param queue The WifiMacQueue object.
@@ -378,6 +357,11 @@
    */
   typedef Callback <void, Ptr<const WifiMacQueueItem>> TxFailed;
   /**
+   * typedef for a callback to invoke when an MPDU is dropped.
+   */
+  typedef Callback <void, Ptr<const WifiMacQueueItem>> DroppedOldMpdu;
+
+  /**
    * \param callback the callback to invoke when a
    * packet transmission was completed successfully.
    */
@@ -387,6 +371,10 @@
    * packet transmission was completed unsuccessfully.
    */
   void SetTxFailedCallback (TxFailed callback);
+  /**
+   * \param callback the callback to invoke when an old MPDU is dropped
+   */
+  void SetDroppedOldMpduCallback (DroppedOldMpdu callback);
 
   /**
    * TracedCallback signature for state changes.
@@ -431,6 +419,9 @@
    */
   void ScheduleBar (Ptr<const WifiMacQueueItem> bar, bool skipIfNoDataQueued = false);
 
+protected:
+  void DoDispose () override;
+
 private:
   /**
    * Inactivity timeout function
@@ -440,18 +431,6 @@
   void InactivityTimeout (Mac48Address recipient, uint8_t tid);
 
   /**
-   * Remove packets from the retransmit queue and from the queue of outstanding
-   * packets that become old after setting the starting sequence number for the
-   * agreement with recipient equal to <i>recipient</i> and TID equal to <i>tid</i>
-   * to the given <i>startingSeq</i>.
-   *
-   * \param recipient the recipient MAC address
-   * \param tid Traffic ID
-   * \param startingSeq the new starting sequence number
-   */
-  void RemoveOldPackets (Mac48Address recipient, uint8_t tid, uint16_t startingSeq);
-
-  /**
    * typedef for a list of WifiMacQueueItem.
    */
   typedef std::list<Ptr<WifiMacQueueItem>> PacketQueue;
@@ -480,33 +459,21 @@
                    std::pair<OriginatorBlockAckAgreement, PacketQueue> >::const_iterator AgreementsCI;
 
   /**
-   * \param mpdu the packet to insert in the retransmission queue
-   *
-   * Insert <i>mpdu</i> in retransmission queue.
-   * This method ensures packets are retransmitted in the correct order.
+   * Handle the given in flight MPDU based on its given status. If the status is
+   * ACKNOWLEDGED, the MPDU is removed from both the EDCA queue and the queue of
+   * in flight MPDUs. If the status is TO_RETRANSMIT, the MPDU is only removed
+   * from the queue of in flight MPDUs. Note that the MPDU is removed from both
+   * queues (independently of the status) if the MPDU is not stored in the EDCA
+   * queue, is an old packet or its lifetime expired.
+   *
+   * \param mpduIt an iterator pointing to the MPDU in the queue of in flight MPDUs
+   * \param status the status of the in flight MPDU
+   * \param it iterator pointing to the Block Ack agreement
+   * \param now the current time
+   * \return an iterator pointing to the next MPDU in the queue of in flight MPDUs
    */
-  void InsertInRetryQueue (Ptr<WifiMacQueueItem> mpdu);
-
-  /**
-   * Remove an item from retransmission queue.
-   * This method should be called when packets are acknowledged.
-   *
-   * \param address recipient MAC address of the packet to be removed
-   * \param tid Traffic ID of the packet to be removed
-   * \param seq sequence number of the packet to be removed
-   */
-  void RemoveFromRetryQueue (Mac48Address address, uint8_t tid, uint16_t seq);
-
-  /**
-   * Remove a range of items from retransmission queue.
-   * This method should be called when packets are acknowledged.
-   *
-   * \param address recipient MAC address of the packet to be removed
-   * \param tid Traffic ID of the packet to be removed
-   * \param startSeq sequence number of the first packet to be removed
-   * \param endSeq sequence number of the last packet to be removed
-   */
-  void RemoveFromRetryQueue (Mac48Address address, uint8_t tid, uint16_t startSeq, uint16_t endSeq);
+  PacketQueueI HandleInFlightMpdu (PacketQueueI mpduIt, MpduStatus status,
+                                    const AgreementsI& it, const Time& now);
 
   /**
    * This data structure contains, for each block ack agreement (recipient, TID), a set of packets
@@ -516,12 +483,6 @@
    */
   Agreements m_agreements;
 
-  /**
-   * This list contains all iterators to stored packets that need to be retransmitted.
-   * A packet needs retransmission if it's indicated as not correctly received in a BlockAck
-   * frame.
-   */
-  Ptr<WifiMacQueue> m_retryPackets;
   std::list<Bar> m_bars; ///< list of BARs
 
   uint8_t m_blockAckThreshold; ///< block ack threshold
@@ -531,7 +492,7 @@
   Callback<void, Mac48Address, uint8_t> m_unblockPackets; ///< unblock packets callback
   TxOk m_txOkCallback;                                    ///< transmit OK callback
   TxFailed m_txFailedCallback;                            ///< transmit failed callback
-  Ptr<WifiRemoteStationManager> m_stationManager;         ///< the station manager
+  DroppedOldMpdu m_droppedOldMpduCallback;                ///< the dropped MPDU callback
 
   /**
    * The trace source fired when a state transition occurred.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/channel-access-manager.cc ns-3.35/src/wifi/model/channel-access-manager.cc
--- ns-3.34/src/wifi/model/channel-access-manager.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/channel-access-manager.cc	2021-10-01 13:26:48.000000000 -0700
@@ -333,6 +333,7 @@
     {
       Ptr<Txop> txop = *i;
       if (txop->GetAccessStatus () == Txop::REQUESTED
+          && (!txop->IsQosTxop () || !StaticCast<QosTxop> (txop)->EdcaDisabled ())
           && GetBackoffEndFor (txop) <= Simulator::Now () )
         {
           /**
@@ -374,7 +375,7 @@
             {
               for (auto& collidingTxop : internalCollisionTxops)
                 {
-                  collidingTxop->NotifyInternalCollision ();
+                  m_feManager->NotifyInternalCollision (collidingTxop);
                 }
               break;
             }
@@ -404,17 +405,18 @@
 {
   NS_LOG_FUNCTION (this);
   Time lastRxEnd = m_lastRxStart + m_lastRxDuration;
-  Time rxAccessStart = lastRxEnd + GetSifs ();
+  const Time& sifs = GetSifs();
+  Time rxAccessStart = lastRxEnd + sifs;
   if ((lastRxEnd <= Simulator::Now ()) && !m_lastRxReceivedOk)
     {
       rxAccessStart += GetEifsNoDifs ();
     }
-  Time busyAccessStart = m_lastBusyStart + m_lastBusyDuration + GetSifs ();
-  Time txAccessStart = m_lastTxStart + m_lastTxDuration + GetSifs ();
-  Time navAccessStart = m_lastNavStart + m_lastNavDuration + GetSifs ();
-  Time ackTimeoutAccessStart = m_lastAckTimeoutEnd + GetSifs ();
-  Time ctsTimeoutAccessStart = m_lastCtsTimeoutEnd + GetSifs ();
-  Time switchingAccessStart = m_lastSwitchingStart + m_lastSwitchingDuration + GetSifs ();
+  Time busyAccessStart = m_lastBusyStart + m_lastBusyDuration + sifs;
+  Time txAccessStart = m_lastTxStart + m_lastTxDuration + sifs;
+  Time navAccessStart = m_lastNavStart + m_lastNavDuration + sifs;
+  Time ackTimeoutAccessStart = m_lastAckTimeoutEnd + sifs;
+  Time ctsTimeoutAccessStart = m_lastCtsTimeoutEnd + sifs;
+  Time switchingAccessStart = m_lastSwitchingStart + m_lastSwitchingDuration + sifs;
   Time accessGrantedStart;
   if (ignoreNav)
     {
@@ -542,6 +544,19 @@
 }
 
 void
+ChannelAccessManager::DisableEdcaFor (Ptr<Txop> qosTxop, Time duration)
+{
+  NS_LOG_FUNCTION (this << qosTxop << duration);
+  NS_ASSERT (qosTxop->IsQosTxop ());
+  UpdateBackoff ();
+  Time resume = Simulator::Now () + duration;
+  NS_LOG_DEBUG ("Backoff will resume at time " << resume << " with "
+                << qosTxop->GetBackoffSlots () << " remaining slot(s)");
+  qosTxop->UpdateBackoffSlotsNow (0, resume);
+  DoRestartAccessTimeoutIfNeeded ();
+}
+
+void
 ChannelAccessManager::NotifyRxStartNow (Time duration)
 {
   NS_LOG_FUNCTION (this << duration);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/channel-access-manager.h ns-3.35/src/wifi/model/channel-access-manager.h
--- ns-3.34/src/wifi/model/channel-access-manager.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/channel-access-manager.h	2021-10-01 13:26:48.000000000 -0700
@@ -115,6 +115,17 @@
   Time GetAccessGrantStart (bool ignoreNav = false) const;
 
   /**
+   * \param qosTxop a QosTxop that needs to be disabled
+   * \param duration the amount of time during which the QosTxop is disabled
+   *
+   * Disable the given EDCA for the given amount of time. This EDCA will not be
+   * granted channel access during this period and the backoff timer will be frozen.
+   * After this period, the EDCA will start normal operations again by resuming
+   * the backoff timer.
+   */
+  void DisableEdcaFor (Ptr<Txop> qosTxop, Time duration);
+
+  /**
    * \param duration expected duration of reception
    *
    * Notify the Txop that a packet reception started
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/frame-exchange-manager.cc ns-3.35/src/wifi/model/frame-exchange-manager.cc
--- ns-3.34/src/wifi/model/frame-exchange-manager.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/frame-exchange-manager.cc	2021-10-01 13:26:48.000000000 -0700
@@ -281,7 +281,7 @@
     }
 
   m_dcf->NotifyChannelAccessed ();
-  Ptr<WifiMacQueueItem> mpdu = *queue->Peek ()->GetQueueIteratorPairs ().front ().it;
+  Ptr<WifiMacQueueItem> mpdu = *queue->Peek ()->GetQueueIterator ();
   NS_ASSERT (mpdu != 0);
   NS_ASSERT (mpdu->GetHeader ().IsData () || mpdu->GetHeader ().IsMgt ());
 
@@ -327,15 +327,15 @@
     {
       NS_LOG_DEBUG ("Fragmenting the MSDU");
       m_fragmentedPacket = mpdu->GetPacket ()->Copy ();
+      AcIndex ac = mpdu->GetQueueAc ();
       // dequeue the MSDU
-      WifiMacQueueItem::QueueIteratorPair queueIt = mpdu->GetQueueIteratorPairs ().front ();
-      queueIt.queue->Dequeue (queueIt.it);
+      DequeueMpdu (mpdu);
       // create the first fragment
       mpdu->GetHeader ().SetMoreFragments ();
       Ptr<Packet> fragment = m_fragmentedPacket->CreateFragment (0, m_mac->GetWifiRemoteStationManager ()->GetFragmentSize (mpdu, 0));
       // enqueue the first fragment
       Ptr<WifiMacQueueItem> item = Create<WifiMacQueueItem> (fragment, mpdu->GetHeader (), mpdu->GetTimeStamp ());
-      queueIt.queue->PushFront (item);
+      m_mac->GetTxopQueue (ac)->PushFront (item);
       return item;
     }
   return mpdu;
@@ -395,6 +395,13 @@
   if (m_txParams.m_acknowledgment->method == WifiAcknowledgment::NONE)
     {
       Simulator::Schedule (txDuration, &FrameExchangeManager::TransmissionSucceeded, this);
+
+      if (!m_mpdu->GetHeader ().IsQosData ()
+          || m_mpdu->GetHeader ().GetQosAckPolicy () == WifiMacHeader::NO_ACK)
+        {
+          // No acknowledgment, hence dequeue the MPDU if it is stored in a queue
+          DequeueMpdu (m_mpdu);
+        }
     }
   else if (m_txParams.m_acknowledgment->method == WifiAcknowledgment::NORMAL_ACK)
     {
@@ -436,22 +443,17 @@
 {
   NS_LOG_FUNCTION (this << *mpdu << txVector);
 
-  // The MPDU is about to be transmitted, we can now dequeue it if it is stored in a queue
-  DequeueMpdu (mpdu);
-
   m_phy->Send (Create<WifiPsdu> (mpdu, false), txVector);
 }
 
 void
-FrameExchangeManager::DequeueMpdu (Ptr<WifiMacQueueItem> mpdu)
+FrameExchangeManager::DequeueMpdu (Ptr<const WifiMacQueueItem> mpdu)
 {
   NS_LOG_DEBUG (this << *mpdu);
 
   if (mpdu->IsQueued ())
     {
-      WifiMacQueueItem::QueueIteratorPair queueIt = mpdu->GetQueueIteratorPairs ().front ();
-      NS_ASSERT (*queueIt.it == mpdu);
-      queueIt.queue->Dequeue (queueIt.it);
+      m_mac->GetTxopQueue (mpdu->GetQueueAc ())->DequeueIfQueued (mpdu);
     }
 }
 
@@ -775,6 +777,8 @@
     {
       NS_LOG_DEBUG ("Missed Ack, discard MPDU");
       NotifyPacketDiscarded (mpdu);
+      // Dequeue the MPDU if it is stored in a queue
+      DequeueMpdu (mpdu);
       m_mac->GetWifiRemoteStationManager ()->ReportFinalDataFailed (mpdu);
       m_dcf->ResetCw ();
     }
@@ -794,9 +798,6 @@
 FrameExchangeManager::RetransmitMpduAfterMissedAck (Ptr<WifiMacQueueItem> mpdu) const
 {
   NS_LOG_FUNCTION (this << *mpdu);
-
-  // insert the MPDU in the DCF queue again
-  m_dcf->GetWifiMacQueue ()->PushFront (mpdu);
 }
 
 void
@@ -841,6 +842,45 @@
 }
 
 void
+FrameExchangeManager::NotifyInternalCollision (Ptr<Txop> txop)
+{
+  NS_LOG_FUNCTION (this);
+
+  // For internal collisions occurring with the EDCA access method, the appropriate
+  // retry counters (short retry counter for MSDU, A-MSDU, or MMPDU and QSRC[AC] or
+  // long retry counter for MSDU, A-MSDU, or MMPDU and QLRC[AC]) are incremented
+  // (Sec. 10.22.2.11.1 of 802.11-2016).
+  // We do not prepare the PSDU that the AC losing the internal collision would have
+  // sent. As an approximation, we consider the frame peeked from the queues of the AC.
+  Ptr<QosTxop> qosTxop = (txop->IsQosTxop () ? StaticCast<QosTxop> (txop) : nullptr);
+
+  Ptr<const WifiMacQueueItem> mpdu = (qosTxop != nullptr ? qosTxop->PeekNextMpdu ()
+                                                         : txop->GetWifiMacQueue ()->Peek ());
+
+  if (mpdu != nullptr)
+    {
+      m_mac->GetWifiRemoteStationManager ()->ReportDataFailed (mpdu);
+
+      if (!mpdu->GetHeader ().GetAddr1 ().IsGroup ()
+          && !m_mac->GetWifiRemoteStationManager ()->NeedRetransmission (mpdu))
+        {
+          NS_LOG_DEBUG ("reset DCF");
+          m_mac->GetWifiRemoteStationManager ()->ReportFinalDataFailed (mpdu);
+          DequeueMpdu (mpdu);
+          NotifyPacketDiscarded (mpdu);
+          txop->ResetCw ();
+        }
+      else
+        {
+          NS_LOG_DEBUG ("Update CW");
+          txop->UpdateFailedCw ();
+        }
+    }
+
+  txop->Txop::NotifyChannelReleased ();
+}
+
+void
 FrameExchangeManager::NotifySwitchingStartNow (Time duration)
 {
   NS_LOG_DEBUG ("Switching channel. Cancelling MAC pending events");
@@ -1102,6 +1142,9 @@
   // a frame containing all or part of an MSDU or MMPDU (sec. 10.3.3 of 802.11-2016)
   m_dcf->ResetCw ();
 
+  // The MPDU has been acknowledged, we can now dequeue it if it is stored in a queue
+  DequeueMpdu (mpdu);
+
   if (mpdu->GetHeader ().IsMoreFragments ())
     {
       // enqueue the next fragment
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/frame-exchange-manager.h ns-3.35/src/wifi/model/frame-exchange-manager.h
--- ns-3.34/src/wifi/model/frame-exchange-manager.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/frame-exchange-manager.h	2021-10-01 13:26:48.000000000 -0700
@@ -122,7 +122,7 @@
    */
   virtual void SetWifiPhy (const Ptr<WifiPhy> phy);
   /**
-   * Remove WifiPhy associated with this MacLow.
+   * Remove WifiPhy associated with this FrameExchangeManager.
    */
   virtual void ResetPhy (void);
   /**
@@ -213,23 +213,30 @@
   virtual void CalculateAcknowledgmentTime (WifiAcknowledgment* acknowledgment) const;
 
   /**
+   * Notify that an internal collision has occurred for the given Txop
+   *
+   * \param txop the Txop for which an internal collision has occurred
+   */
+  virtual void NotifyInternalCollision (Ptr<Txop> txop);
+
+  /**
    * \param duration switching delay duration.
    *
-   * This method is typically invoked by the PhyMacLowListener to notify
+   * This method is typically invoked by the PhyListener to notify
    * the MAC layer that a channel switching occurred. When a channel switching
    * occurs, pending MAC transmissions (RTS, CTS, Data and Ack) are cancelled.
    */
   void NotifySwitchingStartNow (Time duration);
 
   /**
-   * This method is typically invoked by the PhyMacLowListener to notify
+   * This method is typically invoked by the PhyListener to notify
    * the MAC layer that the device has been put into sleep mode. When the device is put
    * into sleep mode, pending MAC transmissions (RTS, CTS, Data and Ack) are cancelled.
    */
   void NotifySleepNow (void);
 
   /**
-   * This method is typically invoked by the PhyMacLowListener to notify
+   * This method is typically invoked by the PhyListener to notify
    * the MAC layer that the device has been put into off mode. When the device is put
    * into off mode, pending MAC transmissions (RTS, CTS, Data and Ack) are cancelled.
    */
@@ -396,7 +403,7 @@
    *
    * \param mpdu the given MPDU
    */
-  virtual void DequeueMpdu (Ptr<WifiMacQueueItem> mpdu);
+  virtual void DequeueMpdu (Ptr<const WifiMacQueueItem> mpdu);
 
   /**
    * Compute how to set the Duration/ID field of a frame being transmitted with
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/he/he-configuration.cc ns-3.35/src/wifi/model/he/he-configuration.cc
--- ns-3.34/src/wifi/model/he/he-configuration.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/he/he-configuration.cc	2021-10-01 13:26:48.000000000 -0700
@@ -58,6 +58,114 @@
                    MakeUintegerAccessor (&HeConfiguration::GetMpduBufferSize,
                                          &HeConfiguration::SetMpduBufferSize),
                    MakeUintegerChecker<uint16_t> (64, 256))
+    .AddAttribute ("MuBeAifsn",
+                   "AIFSN used by BE EDCA when the MU EDCA Timer is running. "
+                   "It must be either zero (EDCA disabled) or a value from 2 to 15.",
+                   UintegerValue (0),
+                   MakeUintegerAccessor (&HeConfiguration::m_muBeAifsn),
+                   MakeUintegerChecker<uint8_t> (0, 15))
+    .AddAttribute ("MuBkAifsn",
+                   "AIFSN used by BK EDCA when the MU EDCA Timer is running. "
+                   "It must be either zero (EDCA disabled) or a value from 2 to 15.",
+                   UintegerValue (0),
+                   MakeUintegerAccessor (&HeConfiguration::m_muBkAifsn),
+                   MakeUintegerChecker<uint8_t> (0, 15))
+    .AddAttribute ("MuViAifsn",
+                   "AIFSN used by VI EDCA when the MU EDCA Timer is running. "
+                   "It must be either zero (EDCA disabled) or a value from 2 to 15.",
+                   UintegerValue (0),
+                   MakeUintegerAccessor (&HeConfiguration::m_muViAifsn),
+                   MakeUintegerChecker<uint8_t> (0, 15))
+    .AddAttribute ("MuVoAifsn",
+                   "AIFSN used by VO EDCA when the MU EDCA Timer is running. "
+                   "It must be either zero (EDCA disabled) or a value from 2 to 15.",
+                   UintegerValue (0),
+                   MakeUintegerAccessor (&HeConfiguration::m_muVoAifsn),
+                   MakeUintegerChecker<uint8_t> (0, 15))
+    .AddAttribute ("MuBeCwMin",
+                   "CWmin used by BE EDCA when the MU EDCA Timer is running. "
+                   "It must be a power of 2 minus 1 in the range from 0 to 32767.",
+                   UintegerValue (15),
+                   MakeUintegerAccessor (&HeConfiguration::m_muBeCwMin),
+                   MakeUintegerChecker<uint16_t> (0, 32767))
+    .AddAttribute ("MuBkCwMin",
+                   "CWmin used by BK EDCA when the MU EDCA Timer is running. "
+                   "It must be a power of 2 minus 1 in the range from 0 to 32767.",
+                   UintegerValue (15),
+                   MakeUintegerAccessor (&HeConfiguration::m_muBkCwMin),
+                   MakeUintegerChecker<uint16_t> (0, 32767))
+    .AddAttribute ("MuViCwMin",
+                   "CWmin used by VI EDCA when the MU EDCA Timer is running. "
+                   "It must be a power of 2 minus 1 in the range from 0 to 32767.",
+                   UintegerValue (15),
+                   MakeUintegerAccessor (&HeConfiguration::m_muViCwMin),
+                   MakeUintegerChecker<uint16_t> (0, 32767))
+    .AddAttribute ("MuVoCwMin",
+                   "CWmin used by VO EDCA when the MU EDCA Timer is running. "
+                   "It must be a power of 2 minus 1 in the range from 0 to 32767.",
+                   UintegerValue (15),
+                   MakeUintegerAccessor (&HeConfiguration::m_muVoCwMin),
+                   MakeUintegerChecker<uint16_t> (0, 32767))
+    .AddAttribute ("MuBeCwMax",
+                   "CWmax used by BE EDCA when the MU EDCA Timer is running. "
+                   "It must be a power of 2 minus 1 in the range from 0 to 32767.",
+                   UintegerValue (1023),
+                   MakeUintegerAccessor (&HeConfiguration::m_muBeCwMax),
+                   MakeUintegerChecker<uint16_t> (0, 32767))
+    .AddAttribute ("MuBkCwMax",
+                   "CWmax used by BK EDCA when the MU EDCA Timer is running. "
+                   "It must be a power of 2 minus 1 in the range from 0 to 32767.",
+                   UintegerValue (1023),
+                   MakeUintegerAccessor (&HeConfiguration::m_muBkCwMax),
+                   MakeUintegerChecker<uint16_t> (0, 32767))
+    .AddAttribute ("MuViCwMax",
+                   "CWmax used by VI EDCA when the MU EDCA Timer is running. "
+                   "It must be a power of 2 minus 1 in the range from 0 to 32767.",
+                   UintegerValue (1023),
+                   MakeUintegerAccessor (&HeConfiguration::m_muViCwMax),
+                   MakeUintegerChecker<uint16_t> (0, 32767))
+    .AddAttribute ("MuVoCwMax",
+                   "CWmax used by VO EDCA when the MU EDCA Timer is running. "
+                   "It must be a power of 2 minus 1 in the range from 0 to 32767.",
+                   UintegerValue (1023),
+                   MakeUintegerAccessor (&HeConfiguration::m_muVoCwMax),
+                   MakeUintegerChecker<uint16_t> (0, 32767))
+    .AddAttribute ("BeMuEdcaTimer",
+                   "The MU EDCA Timer used by BE EDCA. It must be a multiple of "
+                   "8192 us and must be in the range from 8.192 ms to 2088.96 ms. "
+                   "0 is a reserved value, but we allow to use this value to indicate "
+                   "that an MU EDCA Parameter Set element must not be sent. Therefore, "
+                   "0 can only be used if the MU EDCA Timer for all ACs is set to 0.",
+                   TimeValue (MicroSeconds (0)),
+                   MakeTimeAccessor (&HeConfiguration::m_beMuEdcaTimer),
+                   MakeTimeChecker (MicroSeconds (0), MicroSeconds (2088960)))
+    .AddAttribute ("BkMuEdcaTimer",
+                   "The MU EDCA Timer used by BK EDCA. It must be a multiple of "
+                   "8192 us and must be in the range from 8.192 ms to 2088.96 ms."
+                   "0 is a reserved value, but we allow to use this value to indicate "
+                   "that an MU EDCA Parameter Set element must not be sent. Therefore, "
+                   "0 can only be used if the MU EDCA Timer for all ACs is set to 0.",
+                   TimeValue (MicroSeconds (0)),
+                   MakeTimeAccessor (&HeConfiguration::m_bkMuEdcaTimer),
+                   MakeTimeChecker (MicroSeconds (0), MicroSeconds (2088960)))
+    .AddAttribute ("ViMuEdcaTimer",
+                   "The MU EDCA Timer used by VI EDCA. It must be a multiple of "
+                   "8192 us and must be in the range from 8.192 ms to 2088.96 ms."
+                   "0 is a reserved value, but we allow to use this value to indicate "
+                   "that an MU EDCA Parameter Set element must not be sent. Therefore, "
+                   "0 can only be used if the MU EDCA Timer for all ACs is set to 0.",
+                   TimeValue (MicroSeconds (0)),
+                   MakeTimeAccessor (&HeConfiguration::m_viMuEdcaTimer),
+                   MakeTimeChecker (MicroSeconds (0), MicroSeconds (2088960)))
+    .AddAttribute ("VoMuEdcaTimer",
+                   "The MU EDCA Timer used by VO EDCA. It must be a multiple of "
+                   "8192 us and must be in the range from 8.192 ms to 2088.96 ms."
+                   "0 is a reserved value, but we allow to use this value to indicate "
+                   "that an MU EDCA Parameter Set element must not be sent. Therefore, "
+                   "0 can only be used if the MU EDCA Timer for all ACs is set to 0.",
+                   TimeValue (MicroSeconds (0)),
+                   MakeTimeAccessor (&HeConfiguration::m_voMuEdcaTimer),
+                   MakeTimeChecker (MicroSeconds (0), MicroSeconds (2088960)))
     ;
     return tid;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/he/he-configuration.h ns-3.35/src/wifi/model/he/he-configuration.h
--- ns-3.34/src/wifi/model/he/he-configuration.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/he/he-configuration.h	2021-10-01 13:26:48.000000000 -0700
@@ -74,6 +74,22 @@
   Time m_guardInterval;      //!< Supported HE guard interval
   uint8_t m_bssColor;        //!< BSS color
   uint16_t m_mpduBufferSize; //!< MPDU buffer size
+  uint8_t m_muBeAifsn;       //!< AIFSN for BE in MU EDCA Parameter Set
+  uint8_t m_muBkAifsn;       //!< AIFSN for BK in MU EDCA Parameter Set
+  uint8_t m_muViAifsn;       //!< AIFSN for VI in MU EDCA Parameter Set
+  uint8_t m_muVoAifsn;       //!< AIFSN for VO in MU EDCA Parameter Set
+  uint16_t m_muBeCwMin;      //!< CWmin for BE in MU EDCA Parameter Set
+  uint16_t m_muBkCwMin;      //!< CWmin for BK in MU EDCA Parameter Set
+  uint16_t m_muViCwMin;      //!< CWmin for VI in MU EDCA Parameter Set
+  uint16_t m_muVoCwMin;      //!< CWmin for VO in MU EDCA Parameter Set
+  uint16_t m_muBeCwMax;      //!< CWmax for BE in MU EDCA Parameter Set
+  uint16_t m_muBkCwMax;      //!< CWmax for BK in MU EDCA Parameter Set
+  uint16_t m_muViCwMax;      //!< CWmax for VI in MU EDCA Parameter Set
+  uint16_t m_muVoCwMax;      //!< CWmax for VO in MU EDCA Parameter Set
+  Time m_beMuEdcaTimer;      //!< Timer for BE in MU EDCA Parameter Set
+  Time m_bkMuEdcaTimer;      //!< Timer for BK in MU EDCA Parameter Set
+  Time m_viMuEdcaTimer;      //!< Timer for VI in MU EDCA Parameter Set
+  Time m_voMuEdcaTimer;      //!< Timer for VO in MU EDCA Parameter Set
 };
 
 } //namespace ns3
